<template>
    <div>
        <div>
            <button
                class="uk-button uk-button-default uk-align-right"
                type="button"
            >
                Actions
            </button>
            <div uk-dropdown>
                <ul class="uk-nav uk-dropdown-nav">
                    <li v-if="affectationAutorisee">
                        <a :href="'#' + idModalAffectation" uk-toggle>
                            Affecter
                        </a>
                    </li>
                    <li>
                        <a @click="supprimer()">
                            Supprimer
                        </a>
                    </li>
                </ul>
            </div>
        </div>
        <h3 class="uk-heading-line">
            <span>{{ titre }}</span>
        </h3>
        <ListeProbleme
            v-if="exercices.length > 0"
            :problemes="exercices"
            :avecSelection="true"
            :idLecon="idLecon"
            @prendreEnCompteProbleme="prendreEnCompteExercice"
        />
        <AffectationProbleme
            :problemes="exercicesCoches"
            :idModal="idModalAffectation"
        />
    </div>
</template>

<script lang="ts">
import Vue from 'vue';
import Component from 'vue-class-component';
import UIkit from 'uikit';
import ListeProbleme from '@/components/ListeProblemes.vue';
import Axios from '@/auth/axiosAuth';
import AffectationProbleme from '@/components/AffectationProbleme.vue';
import { Prop } from 'vue-property-decorator';

@Component({
    components: { ListeProbleme, AffectationProbleme }
})
export default class ListeExercices extends Vue {
    @Prop() titre: string;
    @Prop() exercicesCharges: any[];
    @Prop() idLecon: string;
    @Prop() typeExercice: string;
    @Prop() affectationAutorisee: boolean;

    private exercicesCoches: any[] = [];
    private exercices: any[] = [];
    private idModalAffectation = '';

    mounted() {
        this.exercices = this.exercicesCharges;
        this.idModalAffectation = 'modal-affectation-' + this.typeExercice;
    }

    public prendreEnCompteExercice(problemesCoches) {
        this.exercicesCoches = problemesCoches;
    }

    private supprimer() {
        if (this.exercicesCoches.length > 0) {
            const formData = new FormData();
            this.exercicesCoches.forEach(id => formData.append('ids', id));
            Axios.post(
                'problemes',
                () => {
                    this.exercicesCoches.forEach(probleme => {
                        const index = this.exercices.findIndex(
                            exo => exo.id === probleme
                        );
                        this.exercices.splice(index, 1);
                    });
                    this.exercicesCoches = [];
                    UIkit.notification('Les problèmes ont bien été supprimés');
                },
                formData,
                error =>
                    UIkit.notification(error.response.data.message, {
                        status: 'danger'
                    })
            );
        }
    }
}
</script>
